** SET UP MACRO VARIABLE FOR WHICH DATA TO  USE **; 
** SET UP GPATH TO SEND GRAPHS TO WORK DIRECTORY RATHER THAN 
   PERMANENT STORAGE AND SET UP LIBNAME FOR DATA **; 
%LET Y=HUNT; TITLE "&Y DATA"; 
OPTIONS SYMBOLGEN;

ODS HTML CLOSE; ODS LISTING; 
ODS LISTING GPATH="%SYSFUNC(PATHNAME(WORK))";
ODS HTML GPATH="%SYSFUNC(PATHNAME(WORK))";
LIBNAME DAD "E:\DH_HILL"; 


 ** (1) REARRANGE THE DATA WITH 3 RESPONSE COLUMNS **; 
 DATA LIB; SET DAD.MNLYCIRCS(RENAME=(CIRCCOUNT=COMBINED)); 
 DATA LIB2; SET DAD.MNLYCIRCS_HUNTSTATUS(RENAME=(CIRCCOUNT=HILL)); 
     WHERE HUNTITEM=0;  
 DATA LIB3; SET DAD.MNLYCIRCS_HUNTSTATUS(RENAME=(CIRCCOUNT=HUNT)); 
     WHERE HUNTITEM=1;   
 DATA ALL; MERGE LIB LIB2 LIB3 END=EOF; T+1;
     TOTAL = HILL+HUNT;WHERE DATE<"01JUL2014"D; 
     ARRAY MON(12); DO I=1 TO 12; MON(I)=(MONTH(DATE)=I); END; 
     PULSE = (DATE = "02JAN2013"D); 
     STEP =  (DATE > "01JAN2013"D); 
     OUTPUT; 
  IF EOF THEN DO LEAD = 1 TO 24; T+1;
    DATE = INTNX("MONTH",DATE,1); 
    TOTAL=.; HILL=.; HUNT=.; &Y=.; COMBINED=.;   
  DO I=1 TO 12; MON(I)=(MONTH(DATE)=I); END;
     OUTPUT; END; 
  PROC PRINT DATA=ALL; FORMAT DATE DATE10.; RUN; 
*** (Figure 5) ***; 
  PROC SGPLOT DATA=ALL; where date < "01jul2014"d;
  TITLE "&Y DATA"; TITLE2 "before and after";
    Scatter Y=&Y X=date;  
    Refline "20Dec2012"D / axis=X; ** Move a bit to the left of Jan **;  
  PROC SGPLOT DATA=ALL; where date < "01jul2014"d; 
    Series Y=&Y X=date;
    Refline "20Dec2012"D / axis=X;
run; 


** (2) OPTIONAL: CODE TO THE SUMMING TO 0 MODEL **; 
 DATA ALL; SET ALL; ARRAY MON(12) MON1-MON12; 
  DO I=1 TO 11; MON(I)=MON(I)-MON(12); END; * */ ; 

** (3) ANALYZE WITH REG **; 
PROC REG DATA=ALL; 
  MODEL &Y=STEP; 
  MODEL &Y=STEP MON1 - MON11; 
  OUTPUT OUT=OUTREG PREDICTED=P RESIDUAL=R&Y; 
  RUN; 
  DATA OUTREG;  SET OUTREG; 
 * Y = 8978.70833 - 842.56667*STEP; * TOTAL *; 
 * Y = 7607.58333 - 931.16667*STEP; * HILL *; 
   Y = 1371.12500 +  88.60000*STEP; * HUNT *; 

PROC SGPLOT DATA=OUTREG; 
 SCATTER X=DATE Y=&Y; 
 SERIES X=DATE Y=P; 
 SERIES X=DATE Y=Y/GROUP=STEP LINEATTRS=(THICKNESS=2.5 COLOR=RED);
 REFLINE "15JUN2014"D/AXIS=X;  
RUN; 
PROC SGPLOT DATA=OUTREG; 
 SERIES X=DATE Y=R&Y / MARKERS;  
 WHERE DATE < "15JUN2014"D; 
 REFLINE "01JAN2013"D/AXIS=X; 
RUN; 

** (4) ANALYZE WITH ARIMA **; 
ODS HTML; 
ODS  OUTPUT PARAMETERESTIMATES=BETAS; 
ODS LISTING GPATH="%SYSFUNC(PATHNAME(WORK))";
PROC ARIMA DATA=ALL PLOTS= ALL;
  IDENTIFY VAR=&Y 
   CROSSCOR = (MON1 MON2 MON3 MON4 MON5 MON6 MON7 MON8 MON9 MON10 MON11 MON12  STEP PULSE) 
   NOPRINT; RUN ; 
  ESTIMATE INPUT = (STEP MON1 MON2 MON3 MON4 MON5 MON6 MON7 MON8 MON9 MON10 MON11) 
    P=(1)(12) ML; 
  FORECAST LEAD=12 ID=DATE INTERVAL= MONTH OUT=OUT1; 
RUN; 
ODS HTML CLOSE; 

** (5) CAPTURE LEVEL SHIFT WITH MACRO VARIABLES **; 
DATA _NULL_; SET BETAS; 
IF PARAMETER = "MU" THEN CALL SYMPUT("BEFORE",STRIP(ROUND(ESTIMATE,.01))); 
IF PARAMETER = "NUM1" THEN DO;  CALL SYMPUT("AFTER",STRIP(ROUND(ESTIMATE,.01)));
CALL SYMPUT("PROBT",STRIP(ROUND(PROBT,.000000001))); END;
 
** (5) ADD TWO MEANS TO THE DATA FOR PLOTTING **; 
DATA GRAPH; MERGE ALL OUT1; BY DATE; 
MEAN=&BEFORE+&AFTER*STEP; 
TITLE2 "BEFORE INTERVENTION MEAN IS &BEFORE.  CHANGE IS &AFTER (P = &PROBT)";
 PROC SGPLOT DATA=GRAPH; 
 BAND UPPER=U95 LOWER=L95 X=DATE/ TRANSPARENCY = .5; 
 SERIES X=DATE Y=FORECAST; 
 SCATTER X=DATE Y=&Y;
 REFLINE "01JAN2013"D / AXIS=X LINEATTRS=(COLOR=BLUE THICKNESS=1.5); ;
 REFLINE "01JUL2014"D / AXIS=X LINEATTRS=(COLOR=GREEN PATTERN=DASH THICKNESS=2);  
 SERIES X=DATE Y=MEAN / LINEATTRS=(COLOR=RED PATTERN = SOLID THICKNESS=2) GROUP=STEP; 
 RUN; 


**** TRY ADDING A LINEAR TREND ***; 
ODS OUTPUT PARAMETERESTIMATES=BETAT;
PROC ARIMA DATA=ALL PLOTS= ALL;
  IDENTIFY VAR=&Y 
   CROSSCOR = (MON1 MON2 MON3 MON4 MON5 MON6 MON7 MON8 MON9 MON10 MON11 MON12 T STEP PULSE) 
   NOPRINT; RUN ; 
  ESTIMATE INPUT = (STEP T MON1 MON2 MON3 MON4 MON5 MON6 MON7 MON8 MON9 MON10 MON11) 
    P=(1)(12) ML; 
  FORECAST LEAD=12 ID=DATE INTERVAL= MONTH OUT=OUT2; 
RUN; OPTIONS NOCENTER; 
PROC PRINT DATA=BETAT NOOBS; VAR PARAMETER VARIABLE ESTIMATE PROBT; RUN; 


** (4-A) CAPTURE LEVEL SHIFT WITH MACRO VARIABLES **; 
DATA _NULL_; SET BETAT; 
IF PARAMETER = "MU" THEN CALL SYMPUT("BEFORE",ESTIMATE); 
IF PARAMETER = "NUM1" THEN DO;  CALL SYMPUT("AFTER",ESTIMATE);
CALL SYMPUT("PROBT",STRIP(ROUND(PROBT,.000000001))); END;
IF PARAMETER = "NUM2" THEN CALL SYMPUT("SLOPE",ESTIMATE); 
 
** (5-A) ADD TWO // TRENDS TO THE DATA FOR PLOTTING **; 
DATA GRAPH; MERGE ALL OUT2; BY DATE; 
MEAN=&BEFORE+&AFTER*STEP + &SLOPE*T; 
TITLE2 "BEFORE INTERVENTION INTERCEPT IS &BEFORE.  CHANGE IS &AFTER (P = &PROBT)";
TITLE3 "SLOPE IS &SLOPE THROUGOUT"; RUN; 
 PROC SGPLOT DATA=GRAPH; 
 BAND UPPER=U95 LOWER=L95 X=DATE/ TRANSPARENCY = .5; 
 SERIES X=DATE Y=FORECAST; 
 SCATTER X=DATE Y=&Y;
 REFLINE "01JAN2013"D / AXIS=X LINEATTRS=(COLOR=BLUE THICKNESS=1.5); ;
 REFLINE "01JUL2014"D / AXIS=X LINEATTRS=(COLOR=GREEN PATTERN=DASH THICKNESS=2);  
 SERIES X=DATE Y=MEAN / LINEATTRS=(COLOR=RED PATTERN = SOLID THICKNESS=2) GROUP=STEP; 
 RUN; 

 ** (5) REFIT IN JUST PROC REG; 
 PROC REG DATA=ALL;
MODEL &Y = STEP T MON1-MON11; 
DECMBER:TEST -MON1-MON2-MON3-MON4-MON5-MON6-MON7-MON8-MON9-MON10-MON11;
RUN;  

** (6) RESIDUALS **; 
DATA OUT2; MERGE ALL OUT2; 
LR12 = LAG12(RESIDUAL); MONTH = MONTH(DATE); 
PROC SGPLOT DATA=OUT2; 
SERIES X=DATE Y=RESIDUAL; 
RUN; 

PROC SGPLOT DATA=OUT2; 
SCATTER X=LR12 Y=RESIDUAL/GROUP = MONTH ; 
REG X=LR12 Y=RESIDUAL/GROUP = MONTH ;

RUN; 

** (7) NAIVE T TEST **; 
PROC FORMAT; 
  VALUE CHANGE 0="BEFORE" 1="AFTER"; 
PROC TTEST DATA=ALL; 
  VAR &Y; CLASS STEP; 
  FORMAT STEP CHANGE.; RUN;
OPTIONS LS=96; 
PROC REG DATA=ALL; 
 MODEL &Y=STEP; RUN;  
PROC SGPLOT DATA=ALL; 
SCATTER X=DATE Y=&Y; 
RUN; 
PROC SGPLOT DATA=ALL; 
SERIES X=DATE Y=&Y; 
RUN;


